<template>
    <div>
        <!-- Card HTML -->
        <div class="card card-blog card-inverse card-info mb-4" >
            <div @click="goToDetails" role="button">
                <img class="card-img-top" :src="blog.image">
                <div class="card-block p-2">
                    <h4 class="card-title">{{blog.title}}</h4>
                    <div class="card-text">
                        <p class="text-break" v-html="blog.description"></p>
                    </div>
                    <span  class="float-right text-primary ">See more details..</span>
                </div>
            </div>

            <div class="d-flex justify-content-end p-2">
                <button @click.stop="goToEntry" class="btn btn-info btn-sm mr-2">
                    <fa icon="edit"/> Edit
                </button>
                <button type="button" class="btn btn-danger btn-sm" data-toggle="modal" data-target="#delete-modal">
                    <fa icon="trash"/> Remove
                </button>
            </div>

            <div class="card-footer">
                <small>Last updated {{blog.time_elapsed}}</small>
            </div>
        </div>

        <!-- Modal HTML -->
        <div id="delete-modal" class="modal fade">
            <div class="modal-dialog modal-confirm">
                <div class="modal-content">
                    <div class="modal-header flex-column">
                        <h4 class="modal-title w-100">Are you sure?</h4>
                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                    </div>
                    <div class="modal-body">
                        <p>Do you really want to delete blog item? This process cannot be undone.</p>
                    </div>
                    <div class="modal-footer justify-content-center">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal"><fa icon="times-circle"/> Cancel</button>
                        <button type="button" class="btn btn-danger" @click="removeBlog"><fa icon="trash"/> Delete</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

</template>

<script>
    import $ from 'jquery'
    export default {
        name: "BlogCard",
        props:{
            blog:{
                type:Object,
                default:{}
            }
        },
        methods:{
            goToDetails(){
                this.$router.push({
                    name:'blog-details',
                    params:{id:this.blog.id}
                })
            },
            goToEntry(){
                this.$router.push({
                    name:'blog-entry-update',
                    params:{id:this.blog.id}
                })
            },
            async removeBlog(){
                await axios.post('/api/removeBlog',{id:this.blog.id}).then(response =>{
                    if(response.data.success){
                        this.$emit('removedBlog', true);
                        $('#delete-modal').modal('hide');
                        this.$toast.success(response.data.message);
                    }
                    else
                        this.$toast.error(response.data.message);
                }).catch(e =>{
                    this.$toast.error(e);
                });
            }
        },
    }
</script>

<style scoped>
    .modal-confirm {
        color: #636363;
        width: 400px;
    }
    .modal-confirm .modal-content {
        padding: 20px;
        border-radius: 5px;
        border: none;
        text-align: center;
        font-size: 14px;
    }
    .modal-confirm .modal-header {
        border-bottom: none;
        position: relative;
    }
    .modal-confirm h4 {
        text-align: center;
        font-size: 26px;
        margin: 30px 0 -10px;
    }
    .modal-confirm .close {
        position: absolute;
        top: -5px;
        right: -2px;
    }
    .modal-confirm .modal-body {
        color: #999;
    }
    .modal-confirm .modal-footer {
        border: none;
        text-align: center;
        border-radius: 5px;
        font-size: 13px;
        padding: 10px 15px 25px;
    }
    .modal-confirm .modal-footer a {
        color: #999;
    }
    .modal-confirm .icon-box {
        width: 80px;
        height: 80px;
        margin: 0 auto;
        border-radius: 50%;
        z-index: 9;
        text-align: center;
        border: 3px solid #f15e5e;
    }
    .modal-confirm .icon-box i {
        color: #f15e5e;
        font-size: 46px;
        display: inline-block;
        margin-top: 13px;
    }
    .modal-confirm .btn, .modal-confirm .btn:active {
        color: #fff;
        border-radius: 4px;
        background: #60c7c1;
        text-decoration: none;
        transition: all 0.4s;
        line-height: normal;
        min-width: 120px;
        border: none;
        min-height: 40px;
        border-radius: 3px;
        margin: 0 5px;
    }
    .modal-confirm .btn-secondary {
        background: #c1c1c1;
    }
    .modal-confirm .btn-secondary:hover, .modal-confirm .btn-secondary:focus {
        background: #a8a8a8;
    }
    .modal-confirm .btn-danger {
        background: #f15e5e;
    }
    .modal-confirm .btn-danger:hover, .modal-confirm .btn-danger:focus {
        background: #ee3535;
    }
    .trigger-btn {
        display: inline-block;
        margin: 100px auto;
    }

</style>